## ros-indigo-surface-perception 1.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(surface_perception)

## Add support for C++11, supported in ROS Kinetic and newer
# add_definitions(-std=c++11)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS
  cmake_modules
  eigen_conversions
  geometry_msgs
  pcl_conversions
  roscpp
  rospy
  sensor_msgs
  visualization_msgs
  tf
  tf_conversions
)

find_package(Eigen REQUIRED)
find_package(PCL REQUIRED)

## Uncomment this if the package has a setup.py. This macro ensures
## modules and global scripts declared therein get installed
## See http://ros.org/doc/api/catkin/html/user_guide/setup_dot_py.html
# catkin_python_setup()

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
  INCLUDE_DIRS include
  LIBRARIES
    surface_perception_axes_marker
    surface_perception_segmentation
    surface_perception_shape_extraction
    surface_perception_surface_finder
    surface_perception_surface_history_recorder
    surface_perception_visualization
  CATKIN_DEPENDS
    eigen_conversions
    geometry_msgs
    pcl_conversions
    roscpp
    rospy
    sensor_msgs
    visualization_msgs
  DEPENDS
    Eigen
    PCL
)

###########
## Build ##
###########

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${Eigen_INCLUDE_DIRS}
  ${PCL_INCLUDE_DIRS}
)

add_library(surface_perception_axes_marker src/axes_marker.cpp)
add_dependencies(surface_perception_axes_marker ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(surface_perception_axes_marker
  ${catkin_LIBRARIES}
)

add_library(surface_perception_segmentation src/segmentation.cpp)
add_dependencies(surface_perception_segmentation ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(surface_perception_segmentation
  surface_perception_shape_extraction
  surface_perception_surface_finder
  ${catkin_LIBRARIES}
  ${PCL_LIBRARIES})

add_library(surface_perception_shape_extraction src/shape_extraction.cpp)
add_dependencies(surface_perception_shape_extraction ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(surface_perception_shape_extraction
  ${catkin_LIBRARIES}
  ${PCL_LIBRARIES})

add_library(surface_perception_surface_finder src/surface_finder.cpp)
add_dependencies(surface_perception_surface_finder ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(surface_perception_surface_finder
  surface_perception_surface_history_recorder
  ${catkin_LIBRARIES}
)

add_library(surface_perception_surface_history_recorder src/surface_history_recorder.cpp)
add_dependencies(surface_perception_surface_history_recorder ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(surface_perception_surface_history_recorder
  ${catkin_LIBRARIES}
)

add_library(surface_perception_visualization src/visualization.cpp)
add_dependencies(surface_perception_visualization ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})
target_link_libraries(surface_perception_visualization
  surface_perception_axes_marker
  ${catkin_LIBRARIES})

add_executable(surface_perception_demo src/demo_main.cpp)
set_target_properties(surface_perception_demo PROPERTIES OUTPUT_NAME demo PREFIX "")
target_link_libraries(surface_perception_demo
  ${catkin_LIBRARIES}
  surface_perception_segmentation
  surface_perception_visualization)

#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

## Mark executable scripts (Python etc.) for installation
## in contrast to setup.py, you can choose the destination
# install(PROGRAMS
#   scripts/my_python_script
#   DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
# )

## Mark executables and/or libraries for installation
install(TARGETS
  surface_perception_axes_marker
  surface_perception_demo
  surface_perception_segmentation
  surface_perception_shape_extraction
  surface_perception_surface_finder
  surface_perception_surface_history_recorder
  surface_perception_visualization
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark cpp header files for installation
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE
)

#############
## Testing ##
#############

## Add gtest based cpp test target and link libraries
# catkin_add_gtest(${PROJECT_NAME}-test test/test_surface_perception.cpp)
# if(TARGET ${PROJECT_NAME}-test)
#   target_link_libraries(${PROJECT_NAME}-test ${PROJECT_NAME})
# endif()

catkin_add_gtest(surface_perception_shape_extraction-test test/rotation_matrix_test.cpp)
if(TARGET surface_perception_shape_extraction-test)
  target_link_libraries(surface_perception_shape_extraction-test surface_perception_shape_extraction)
endif()

## Add folders to be run by python nosetests
# catkin_add_nosetests(test)

=== debian/changelog ===
ros-indigo-surface-perception (1.0.3-0trusty) trusty; urgency=high

  * Changed pose to be a const ref.
  * Exported axes marker library.
  * Contributors: Justin Huang

 -- Justin Huang <jstn@cs.washington.edu>  Fri, 20 Apr 2018 07:00:00 -0000

ros-indigo-surface-perception (1.0.2-0trusty) trusty; urgency=high

  * Removed warning message for surfaces with no objects.
  * Fixed objects intersecting with surface.
  * Fixed bugs with shape extraction.
  * Decouple the usage of margin_above_surface and max_point_distance
  * Fixed bug with standardizing object orientation (#9 <https://github.com/jstnhuang/surface_perception/issues/9>)
    * Pulled code to standardize object orientations into a separate function
    * Fixed a bug with this function
    * Added tests
    * Added a visualization of the object orientations
  * Updated Doxygen mainpage.
  * Contributors: Justin Huang, Yu-Tang Peng

 -- Justin Huang <jstn@cs.washington.edu>  Wed, 18 Apr 2018 07:00:00 -0000

ros-indigo-surface-perception (1.0.1-0trusty) trusty; urgency=high

  * Allowed surfaces with no object on them.
  * Fixed occasional crashes due to convex hull computation.
  * Added optional point cloud frame argument in demo to support target frame other than base_link.
  * Contributors: Justin Huang, Yu-Tang Peng

 -- Justin Huang <jstn@cs.washington.edu>  Tue, 06 Mar 2018 08:00:00 -0000

ros-indigo-surface-perception (1.0.0-0trusty) trusty; urgency=high

  * Multi-shelf detection
  * Contributors: Justin Huang, Yu-Tang Peng

 -- Justin Huang <jstn@cs.washington.edu>  Tue, 13 Feb 2018 08:00:00 -0000

ros-indigo-surface-perception (0.2.1-0trusty) trusty; urgency=high

  * Make new x-axis the one closer to the data's x-axis.
  * Contributors: Justin Huang

 -- Justin Huang <jstn@cs.washington.edu>  Mon, 28 Aug 2017 07:00:00 -0000

ros-indigo-surface-perception (0.2.0-0trusty) trusty; urgency=high

  * Changed oriented bounding box fitting algorithm so that the x direction always points towards the shorter side.
  * Contributors: Justin Huang

 -- Justin Huang <jstn@cs.washington.edu>  Mon, 28 Aug 2017 07:00:00 -0000

ros-indigo-surface-perception (0.1.3-0trusty) trusty; urgency=high

  * Added mainpage documentation.
  * Contributors: Justin Huang

 -- Justin Huang <jstn@cs.washington.edu>  Mon, 24 Jul 2017 07:00:00 -0000

ros-indigo-surface-perception (0.1.2-0trusty) trusty; urgency=high

  * Fixed header files not being installed.
  * Contributors: Justin Huang

 -- Justin Huang <jstn@cs.washington.edu>  Wed, 19 Jul 2017 07:00:00 -0000

ros-indigo-surface-perception (0.1.1-0trusty) trusty; urgency=high

  * Added missing dependency.
  * Contributors: Justin Huang

 -- Justin Huang <jstn@cs.washington.edu>  Wed, 07 Jun 2017 07:00:00 -0000

ros-indigo-surface-perception (0.1.0-0trusty) trusty; urgency=high

  * Initial implementation of surface_perception.
  * Contributors: Justin Huang

 -- Justin Huang <jstn@cs.washington.edu>  Wed, 07 Jun 2017 07:00:00 -0000

=== debian/control ===
Source: ros-indigo-surface-perception
Section: misc
Priority: extra
Maintainer: Justin Huang <jstn@cs.washington.edu>
Build-Depends: debhelper (>= 9.0.0), ros-indigo-catkin, ros-indigo-cmake-modules, ros-indigo-eigen-conversions, ros-indigo-geometry-msgs, ros-indigo-pcl-conversions, ros-indigo-roscpp, ros-indigo-rospy, ros-indigo-sensor-msgs, ros-indigo-tf, ros-indigo-tf-conversions, ros-indigo-visualization-msgs
Homepage: http://wiki.ros.org/surface_perception
Standards-Version: 3.9.2

Package: ros-indigo-surface-perception
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-eigen-conversions, ros-indigo-geometry-msgs, ros-indigo-pcl-conversions, ros-indigo-roscpp, ros-indigo-rospy, ros-indigo-sensor-msgs, ros-indigo-tf, ros-indigo-tf-conversions, ros-indigo-visualization-msgs
Description: Simple library for segmentation of tabletop and shelf surfaces

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-surface-perception//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
